<?php

namespace App\Models;

use CodeIgniter\Model;
use App\Libraries\GeneralLib;

class NotifikasipengajuanperubahanModel extends Model
{
    protected $table      = 'notifikasi_pengajuan_perubahan';
    protected $primaryKey = 'id_notifikasi_pengajuan_perubahan';

    protected $useAutoIncrement = true;

    protected $returnType     = 'array';
    protected $useSoftDeletes = true;

    protected $allowedFields = ['id_perubahan', 'id_agen','id_pangkalan','tipe','tanggal','pesan','dilihat'];

    // Dates
    protected $useTimestamps = false;
    protected $dateFormat    = 'datetime';
    protected $createdField  = 'created_at';
    protected $updatedField  = 'updated_at';
    protected $deletedField  = 'deleted_at';

    // Validation
    protected $validationRules      = [];
    protected $validationMessages   = [];
    protected $skipValidation       = false;
    protected $cleanValidationRules = true;

    // Callbacks
    protected $allowCallbacks = true;
    protected $beforeInsert   = [];
    protected $afterInsert    = [];
    protected $beforeUpdate   = [];
    protected $afterUpdate    = [];
    protected $beforeFind     = [];
    protected $afterFind      = [];
    protected $beforeDelete   = [];
    protected $afterDelete    = [];

    public function GetDT($request,$extra="")
    {
        $genlib = new GeneralLib();
        $db = db_connect();
        //$builder = $db->table('vpangkalan');
        
        $return_data = array();
        $return_data['draw'] = $request['draw'];

        $where = array();
        foreach($request['columns'] as $item){
            if (($item['searchable']=='true') && (!empty($item['search']['value'])))
            {
                $where[] = $item['data']." like '%".$item['search']['value']."%'";
            }
        }

        if (!empty($request['search']['value']))
        {
            $where = array();
            foreach($request['columns'] as $item){
                if (($item['searchable']=='true'))
                {
                    $where[] = $item['data']." like '%".$request['search']['value']."%'";
                }
            }
        }

        if(isset($request['searchBuilder']))
        {
            $filter = $genlib->dt_traverse_search_builder($request['searchBuilder']);
        }else{
            $filter = implode(" or ",$where);
        }
        //die(var_dump($filter));

        $order_by = $request['columns'][$request['order'][0]['column']]['data'];
        $order = $request['order'][0]['dir'];
        
        $squery = "SELECT
                        notifikasi_pengajuan_perubahan.id_notifikasi_pengajuan_perubahan, 
                        notifikasi_pengajuan_perubahan.id_perubahan,
                        notifikasi_pengajuan_perubahan.id_agen, 
                        notifikasi_pengajuan_perubahan.id_pangkalan, 
                        notifikasi_pengajuan_perubahan.tipe, 
                        notifikasi_pengajuan_perubahan.tanggal, 
                        notifikasi_pengajuan_perubahan.pesan, 
                        notifikasi_pengajuan_perubahan.dilihat, 
                        pangkalan_perubahan.id_registrasi,
                        pangkalan_perubahan.nama_pangkalan
                    FROM
                        notifikasi_pengajuan_perubahan
                        LEFT JOIN
                        pangkalan_perubahan
                        ON 
                            notifikasi_pengajuan_perubahan.id_perubahan = pangkalan_perubahan.id_perubahan";

        $squery_total = "SELECT
                    count(notifikasi_pengajuan_perubahan.id_notifikasi_pengajuan_perubahan) as jumlah
                    FROM
                    notifikasi_pengajuan_perubahan LEFT JOIN
                        pangkalan_perubahan
                        ON 
                            notifikasi_pengajuan_perubahan.id_perubahan = pangkalan_perubahan.id_perubahan";
        
        $squery_total_filtered = "SELECT
                    count(notifikasi_pengajuan_perubahan.id_notifikasi_pengajuan_perubahan) as jumlah
                    FROM
                    notifikasi_pengajuan_perubahan LEFT JOIN
                        pangkalan
                        ON 
                            notifikasi_pengajuan_perubahan.id_perubahan = pangkalan_perubahan.id_perubahan";

        if (!empty($filter))
        {
            $filter = "(".$filter.")";
        }

        if (!empty($extra)){
            $squery_total .= " where ".$extra;
            if (empty($filter)){
                $filter = $extra;
            }else{
                $filter .= " and (".$extra.")";
            }
        }
        
        if (!empty($order_by))
        {
            $order_by = " order by ".$order_by." ".$order;
        }
        
        if (!empty($filter))
        {
            //$data = $builder->where($filter)->orderBy($order_by, $order)->limit($request['start'],$request['length'])->get()->getResult();
            $squery .= " where ".$filter.$order_by." limit ".$request['start'].",".$request['length'];
            $squery_total_filtered .= " where ".$filter;
        }else{
            //$data = $builder->orderBy($order_by, $order)->limit($request['start'],$request['length'])->get()->getResult();
            $squery .= $order_by." limit ".$request['start'].",".$request['length'];
        }
        //die(var_dump($squery));
        //die(var_dump($registrasi));
        $query_total = $db->query($squery_total);
        $query_total_filtered = $db->query($squery_total_filtered);
        $query = $db->query($squery);

        $row_total = $query_total->getRow();
        $row_total_filtered = $query_total_filtered->getRow();
        $data = $query->getResult();

        $return_data['recordsTotal'] = $row_total->jumlah;
        $return_data['recordsFiltered'] =  $row_total_filtered->jumlah;
        $return_data['data'] = $data;

        return json_encode($return_data);
    }

    public function GetDTAgen($request,$id_agen,$extra="")
    {
        $genlib = new GeneralLib();
        $db = db_connect();
        //$builder = $db->table('vpangkalan');
        
        $return_data = array();
        $return_data['draw'] = $request['draw'];

        $where = array();
        foreach($request['columns'] as $item){
            if (($item['searchable']=='true') && (!empty($item['search']['value'])))
            {
                $where[] = $item['data']." like '%".$item['search']['value']."%'";
            }
        }

        if (!empty($request['search']['value']))
        {
            $where = array();
            foreach($request['columns'] as $item){
                if (($item['searchable']=='true'))
                {
                    $where[] = $item['data']." like '%".$request['search']['value']."%'";
                }
            }
        }

        if(isset($request['searchBuilder']))
        {
            $filter = $genlib->dt_traverse_search_builder($request['searchBuilder']);
        }else{
            $filter = implode(" or ",$where);
        }
        //die(var_dump($filter));

        $order_by = $request['columns'][$request['order'][0]['column']]['data'];
        $order = $request['order'][0]['dir'];
        
        $squery = "SELECT
                        notifikasi_pengajuan_perubahan.id_notifikasi_pengajuan_perubahan, 
                        notifikasi_pengajuan_perubahan.id_perubahan,
                        notifikasi_pengajuan_perubahan.id_agen, 
                        notifikasi_pengajuan_perubahan.id_pangkalan, 
                        notifikasi_pengajuan_perubahan.tipe, 
                        notifikasi_pengajuan_perubahan.tanggal, 
                        notifikasi_pengajuan_perubahan.pesan, 
                        notifikasi_pengajuan_perubahan.dilihat, 
                        pangkalan_perubahan.id_registrasi,
                        pangkalan_perubahan.nama_pangkalan
                    FROM
                        notifikasi_pengajuan_perubahan
                        LEFT JOIN
                        pangkalan_perubahan
                        ON 
                            notifikasi_pengajuan_perubahan.id_perubahan = pangkalan_perubahan.id_perubahan where notifikasi_pengajuan_perubahan.id_agen='".$id_agen."'";

        $squery_total = "SELECT
                    count(notifikasi_pengajuan_perubahan.id_notifikasi_pengajuan_perubahan) as jumlah
                    FROM
                    notifikasi_pengajuan_perubahan LEFT JOIN
                        pangkalan_perubahan
                        ON 
                            notifikasi_pengajuan_perubahan.id_perubahan = pangkalan_perubahan.id_perubahan where notifikasi_pengajuan_perubahan.id_agen='".$id_agen."'";
        
        $squery_total_filtered = "SELECT
                    count(notifikasi_pengajuan_perubahan.id_notifikasi_pengajuan_perubahan) as jumlah
                    FROM
                    notifikasi_pengajuan_perubahan LEFT JOIN
                        pangkalan_perubahan
                        ON 
                            notifikasi_pengajuan_perubahan.id_perubahan = pangkalan_perubahan.id_perubahan where notifikasi_pengajuan_perubahan.id_agen='".$id_agen."'";

        if (!empty($filter))
        {
            $filter = "(".$filter.")";
        }

        if (!empty($extra)){
            $squery_total .= " and ".$extra;
            if (empty($filter)){
                $filter = $extra;
            }else{
                $filter .= " and (".$extra.")";
            }
        }

        if (!empty($order_by))
        {
            $order_by = " order by ".$order_by." ".$order;
        }
        
        if (!empty($filter))
        {
            //$data = $builder->where($filter)->orderBy($order_by, $order)->limit($request['start'],$request['length'])->get()->getResult();
            $squery .= " and ".$filter.$order_by." limit ".$request['start'].",".$request['length'];
            $squery_total_filtered .= " and ".$filter;
        }else{
            //$data = $builder->orderBy($order_by, $order)->limit($request['start'],$request['length'])->get()->getResult();
            $squery .= $order_by." limit ".$request['start'].",".$request['length'];
        }
        //die(var_dump($squery));
        //die(var_dump($registrasi));
        $query_total = $db->query($squery_total);
        $query_total_filtered = $db->query($squery_total_filtered);
        $query = $db->query($squery);

        $row_total = $query_total->getRow();
        $row_total_filtered = $query_total_filtered->getRow();
        $data = $query->getResult();

        $return_data['recordsTotal'] = $row_total->jumlah;
        $return_data['recordsFiltered'] =  $row_total_filtered->jumlah;
        $return_data['data'] = $data;

        return json_encode($return_data);
    }

    public function get_latest_notifikasi($count="1",$extra="")
    {
        $genlib = new GeneralLib();
        $db = db_connect();

        $squery = "SELECT
                        notifikasi_pengajuan_perubahan.id_notifikasi_pengajuan_perubahan, 
                        notifikasi_pengajuan_perubahan.id_perubahan,
                        notifikasi_pengajuan_perubahan.id_agen, 
                        notifikasi_pengajuan_perubahan.id_pangkalan, 
                        notifikasi_pengajuan_perubahan.tipe, 
                        notifikasi_pengajuan_perubahan.tanggal, 
                        notifikasi_pengajuan_perubahan.pesan, 
                        notifikasi_pengajuan_perubahan.dilihat, 
                        pangkalan_perubahan.id_registrasi,
                        pangkalan_perubahan.nama_pangkalan
                    FROM
                        notifikasi_pengajuan_perubahan
                        LEFT JOIN
                        pangkalan_perubahan
                        ON 
                            notifikasi_pengajuan_perubahan.id_perubahan = pangkalan_perubahan.id_perubahan where (dilihat='0')";
        
        if (!empty($extra)){
            $squery .= " and ".$extra." order by tanggal desc limit ".$count;
        }else{
            $squery .= " order by tanggal desc limit ".$count;
        }

        $query = $db->query($squery);
        $data = $query->getResult();
        return $data;
    }
}
?>